package p08_funkcje;

import java.util.Arrays;

public class Max {

    /** Funkcja zwraca większą z dwóch liczb */
    static int max(int a, int b) {
        if(a >= b) {
            return a;
        } else {
            return b;
        }
    }
    
    // alternatywne zapisy:
    static int max_v2(int a, int b) {
        if(a >= b)
            return a;
        return b;
    }

    static int max_v3(int a, int b) {
        return a >= b ? a : b;
    }

    static int max_v1(int a, int b, int c) {
        if(a >= b) {
            if(a >= c) {
                return a;
            } else {
                return c;
            }
        } else {
            if(b >= c) {
                return b;
            } else {
                return c;
            }
        }
    }
    
    /** Funkcja zwraca największą z trzech liczb */
    static int max(int a, int b, int c) {
        if(a >= b && a >= c) return a;
        if(b >= c) return b;
        return c;
    }
    
    static int max_v3(int a, int b, int c) {
        return (a >= b && a >= c) ? a : (b >= c) ? b: c;
    }
    
    static int max_v4(int a, int b, int c) {
        return max(max(a, b), c);
    }

    static int max(int a, int b, int c, int d) {
        return max(max(a, b), max(c, d));
    }
    
    static int max_uniwerslany(int... args) {
        if(args == null || args.length == 0) {
            throw new IllegalArgumentException("tablica powinna mieć elementy");
        }
        // uwaga - to nie jest optymalne wydajnościowo. sortowanie nie jest potrzebny, aby znaleźć max
        Arrays.sort(args);
        return args[args.length-1];
    }

    // btw, w Javie istnieje "przeciążanie metod" (overloading), tzn. można definiować
    // wiele metod o tej samej nazwie pod warunkiem, że różnią się liczbą lub typem parametrów
    
    public static void main(String[] args) {
        System.out.println(max(5, 7)); // 7
        System.out.println(max(13, -17)); // 13
        System.out.println(max(9, 9)); // 9
        System.out.println();
        
        System.out.println(max(5, 9, 6)); // 9
        System.out.println(max(9, 9, 7)); // 9
        System.out.println(max(9, 8, 7)); // 9
        System.out.println(max(5, 4, 9)); // 9
        
        System.out.println(max_uniwerslany(5, 3, 7, 3, 5));
    }

}
